; Sound forge 8, braille functions
; Author: The Snowman

include "HJConst.jsh"
Include "forge90Globals.jsh"

int function BrailleCallbackObjectIdentify()
var
	handle hFocus
Let hFocus = GetFocus()
If (SubString (GetWindowName (GetRealWindow (hFocus)), 1, 6) == "Record") then
	return (WT_CUSTOM_CONTROL_BASE+3)
elif (GetWindowClass (hFocus) == "FgMDIChildData") then
	return (WT_CUSTOM_CONTROL_BASE+1)
elif (ThisIsASlider (GetFocus())) then
	return (WT_CUSTOM_CONTROL_BASE+2)
endif
; when a window type is unknown, ie 0, this function is called. 
;It is responsible for returning the subtype code or a custom code for one of
;upto 32 custom controls which maybe defined. 
; for example, if in MSWord, a table is active then you could return wt_TABLE.
;If in MSAccess and the object model exposes a checkbox then you could return 
;WT_CHECKBOX
; note that in most cases, if the window type is unknown, you will also have 
;to override the other braille related functions regardless of whether you map 
;the unknown control to a standard control or to one of the 32 custom controls. 
; to map to one of the 32 custom controls, you must add a section to the jbs 
;for the application. The section must be called [CustomControlN] where N is 
;a number between 1 and 32.
;This function must then return WT_CUSTOM_CONTROL_BASE+N.
;For tables in HTML,
;or Other tables handled by the Virtual Cursor 
return 0
endFunction

Int Function BrailleAddObjectTime (int nSubTypeCode) 
var
	string t

; SayString ("beep")
if (SFLimitBraille & 1) then
	Let SFLimitBraille = SFLimitBraille & -2
	RefreshWindow (GetFocus())
	let t = GetTime (3)
	if (stringLength (t) > 3) then
		Let SFBRLTime = GetTime(1) + " " + GetTime(2) + " <" + t + ">"
;		BrailleAddString (GetTime(1), 0, 0, 0)
;		BrailleAddString (GetTime(2), 0, 0, 0)
	else
		Let SFBRLTime = GetTime (1)
	endif
endif
BrailleAddString (SFBRLTime,0, 0, 0)
return (TRUE)
EndFunction

Void Function BrailleAddObjectPlayLevel (int nSubTypeCode)
; level meters, in play mode
var
	handle h,
	handle grip,
	string sLevels,
	string str

Let grip = GetParent (GetFocus())
Let grip = GetPriorWindow (grip)
Let grip = GetPriorWindow (grip)
Let grip = GetFirstChild (grip)
if (GetWindowName(grip) == "Channel Meters") then
	Let sLevels = GetMeterReading (grip, 0, 0) + " " + GetMeterReading (grip, 1, 0) 
	BrailleAddString (sLevels,0, 0, 0)
endif
return (TRUE)
EndFunction

Int Function BrailleAddObjectRecordTime (int nSubTypeCode) 
var
	handle hwnd

; beep()
if (SFLimitBraille & 1) then
	Let SFLimitBraille = SFLimitBraille & -2
;	let t = GetTime (3)
	Let hwnd = GetRealWindow (GetFocus())
	Let hwnd = FindDescendantWindow (hwnd, 4089)
	if (hwnd) then
		Let SFBRLTime = GetWindowText (hwnd, 0)
	else
		return(0)
	endif  
endif
BrailleAddString (SFBRLTime,0, 0, 0)
return (TRUE)
EndFunction

Void Function BrailleAddObjectRecordLevel (int nSubTypeCode)
; level meters, in record mode
var
	int channel,
	handle h,
	string str

Let h = GetTopLevelWindow (GetFocus())
Let h = FindDescendantWindow (h, 4056)
if (h) then
	SaveCursor()
	InvisibleCursor()
	MoveToWindow (h)
	Let channel = 1
	While (channel >= 0)
			Let channel = channel-1
			if (FindString (h, ".", S_NEXT, S_RESTRICTED)) then
				if (channel >= 0) then
					let str = GetChunk()
				else
					let str = str + " " + GetChunk()
				endif
			else
;				SayString ("No meters")
				Let channel = -1  ; terminate loop
				return
			Endif
		EndWhile




/*
	Let str = GetChunk()
	; when clipping occurs, the meters are written in two chunks
	if (str == "clip") then
		; left meter clipped
		NextChunk()
		Let str = str + " " + GetChunk()
	elif (StringLength (str) < 6) then
		; right meter clipped
		NextChunk()
		Let str = str + " " + GetChunk()
	endif
*/
	BrailleAddString (str,0, 0, 0)
	RestoreCursor()
endif
return (TRUE)
EndFunction

Int Function BrailleAddObjectSliderLabel ()
BrailleAddString (SFBRLSliderLabel, 0, 0, 0)
return (1)
EndFunction

Int Function BrailleAddObjectSliderValue ()
BrailleAddString (SFBRLSliderValue, 0, 0, 0)
return (1)
EndFunction

